// npx cdt clone --clone:type=git --clone:url= --clone:branch=master --clone:cacheDir=./ --clone:proj:name=commonConfig

const { spawn } = require("child_process");
const { getClonedDirectory } = require("../utils/getFsUtils");
const { Logger } = require("../utils/Logger");
const { getRepoName } = require("../pre-commit");
const cloneRepoProperties = {
  endPoint:
    "https://rajasekar.hm:JzPFGpj2fayCG1cJGKUz@zgit.csez.zohocorpin.com/code_standard/client_linter/linter_configuration.git",
  branch: "master",
  cacheDirectory: "./",
  name: "configuration",
  type: "git"
};

function cloneViaCli() {
  const prefix = "npx";
  const command = [
    `cdt`,
    `clone`,
    `--clone:type=${cloneRepoProperties.type}`,
    `--clone:url=${cloneRepoProperties.endPoint}`,
    `--clone:branch=${cloneRepoProperties.branch}`,
    `--clone:cacheDir=${cloneRepoProperties.cacheDirectory}`,
    `--clone:proj:name=${cloneRepoProperties.name}`
  ];
  return new Promise((resolve) => {
    const cloneProcess = spawn(prefix,command,{cwd:getClonedDirectory() })
    cloneProcess.on('end',() =>{
      Logger.log(Logger.SUCCESS_TYPE,`Lint Configuration Cloned Successfully - ${getRepoName()}`)
      resolve(true)
    })
  })
}

module.exports = { 
    cloneViaCli
}
